#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
# include <rastriginproblem.h>
# include <simplexmethod.h>
# include <camel.h>
# include <test2n.h>
int main()
{
    const int iters = 100;
    double globalMinimum ;
    vector<double> minimaFound;
    for(int i=1;i<=iters;i++)
    {
        srand(i);
        Test2N mytest(4);
        SimplexMethod mysimplex(&mytest);
        mysimplex.runAlgorithm();
        Data bestx = mysimplex.getBestx();
        double besty = mytest.funmin(bestx);
        printf("Iteration %d Besty  %lf\n",i,besty);
        if(i==1 || besty<globalMinimum)
            globalMinimum = besty;
        minimaFound.push_back(besty);
    }
    printf("Found global %lf \n",globalMinimum);


    for(int i=0;i<minimaFound.size();i++)
    {
        printf("Minima[%d]=%lf\n",i,minimaFound[i]);
    }

    int foundMinima = 0;
    for(int i=0;i<minimaFound.size();i++)
    {
        if(fabs(minimaFound[i]-globalMinimum)<1e-2)
            foundMinima++;
    }
    printf("Success rate %.2lf%%\n",foundMinima*100.0/minimaFound.size());
    return 0;
}
